/**
 * @file main.c
 * Exemplos de diferentes tipos de dados basicos e derivados em C
 * 
 * @author Wu Shin Ting
 * @date 19 de agosto de 2020
 */

/*
 * Declaracao de funcoes
 */
int add (int a, int b);
void sub (void);

/**
 * @brief variavel global
 */
float d;
/**
 * @brief variavel global
 */
float e;
/**
 * @brief variavel global
 */
float f;

/**
 * @brief programa-demo de uso de diferentes tipos de dados
 */
int main(void)
{
	// declarar variaveis de tipos de dado basicos
	// declarar uma variavel com modificador de acesso
	const char valor =218;
	volatile char vol_c;

	// declarar uma variavel de classe de armazenamento register
	register unsigned int r_ui;

	// por default, sao de classe de armazenamento auto
	char c;
	signed char sc;
	unsigned short us;
	short s;
	unsigned int ui;
	int counter;
	float x;
	double xx;
		
	// declarar variaveis de tipo de dado derivado
	char array_c[5];
	short array_s[5];
	int array_res[5];
	float array_x[5];
	double array_xx[5];
	
	char *end_c;
	int *end_counter;

	// verificar o tamanho dos tipos basicos pela vista Variables
	// as variaveis tam_* foram declaradas como tipo signed char
	// porque 7 bits sao suficientes para representar os valores
	signed char tam_char = sizeof(c);
	signed char tam_signed_char = sizeof(sc);
	signed char tam_unsigned_short = sizeof (us);
	signed char tam_short = sizeof (s);
	signed char tam_unsigned_int = sizeof (ui);
	signed char tam_int = sizeof (counter);
	signed char tam_float = sizeof (x);
	signed char tam_double = sizeof (xx);
	
	// verificar o tamanho do tipo derivado array pela vista Variables
	signed char tam_array_c = sizeof (array_c); // sizeof = funcao que identifica o espaco alocado para variavel em bytes
	signed char tam_array_s = sizeof (array_s);
	signed char tam_array_res = sizeof (array_res);
	signed char tam_array_x = sizeof (array_x);
	signed char tam_array_xx = sizeof (array_xx);

	// verificar o tamanho do tipo derivado pointer pela vista Variables 
	signed char tam_end_c = sizeof (end_c);
	signed char tam_end_counter = sizeof (end_counter);
	
	// inicializar variaveis
   	c = 'A';
   	sc = -20;
   	us = 2895;
   	s = -2895;
   	ui = 30000000;
   	counter = 0;
   	x = 0.245;
   	xx = 0.245;
   	
   	r_ui = 50;
  
   	vol_c = 'C';
   	
   	d = 30.0;
   	e = 20.0;
   	
   	// atribuir o endereco das variaveis c e counter
   	end_c = &c;
   	end_counter = &counter;
   	
   	// atribuir as variaveis os valores apontados pelos enderecos
   	vol_c = *end_c;
   	ui = *end_counter;
   	   	   	
	for(;;) {	   
	   	counter++;
	   	
	   	// somar counter e valor
	   	ui = add (counter, valor);
	   	
	   	// atualizar os operandos de subracao
	   	d = d + 5.;
	   	e = e + 2.;
	   	sub ();
	   	
	   	// escrever o resultado da subtracao no elemento de indice (counter-1)%5
	   	array_x [(counter-1)%5] = f;   //operador % retorna o resto de uma divisao inteira
	}

	return 0;
}

